## gr-framework 0.73.8+dfsg

=== debian/changelog ===
gr-framework (0.73.8+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * debian/control
    - Use linux-any to exclude hurd-amd64, hurd-i386.

 -- HAYASHI Kentaro <kenhys@xdump.org>  Wed, 30 Oct 2024 19:57:54 +0900

gr-framework (0.73.7+dfsg-2) unstable; urgency=medium

  * Team upload.
  * No change source-only upload for testing migration.

 -- Boyuan Yang <byang@debian.org>  Mon, 16 Sep 2024 23:08:07 -0400

gr-framework (0.73.7+dfsg-1) unstable; urgency=medium

  * Initial release. (Closes: #1077974)

 -- HAYASHI Kentaro <kenhys@xdump.org>  Mon, 05 Aug 2024 20:54:46 +0900
