=== debian/tests/control ===
Tests: plugin-agg plugin-cairo plugin-gs plugin-video
Depends:
 @builddeps@,
 gr-framework-plugin-agg,
 gr-framework-plugin-base,
 gr-framework-plugin-cairo,
 gr-framework-plugin-gl,
 gr-framework-plugin-gs,
 gr-framework-plugin-video,
 libgr-framework-dev,
 mediainfo
