=== debian/changelog ===
gr-framework (0.73.10+dfsg-2build1) plucky; urgency=medium

  * No-change rebuild for fixed libagg2t64 dependency.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 13 Jan 2025 19:59:44 +0100

gr-framework (0.73.10+dfsg-2) unstable; urgency=medium

  * debian/rules:
    - Fix wrong shlibs:Depends= for agg plugin

 -- Kentaro Hayashi <kenhys@xdump.org>  Wed, 25 Dec 2024 19:25:39 +0900

gr-framework (0.73.10+dfsg-1) unstable; urgency=medium

  * New upstream version 0.73.10+dfsg

 -- Kentaro Hayashi <kenhys@xdump.org>  Sun, 22 Dec 2024 19:41:32 +0900

gr-framework (0.73.9+dfsg-1) unstable; urgency=medium

  * New upstream version 0.73.9+dfsg
  * debian/control:
    - Fix W:intra-source-package-circular-dependency.

 -- Kentaro Hayashi <kenhys@xdump.org>  Tue, 10 Dec 2024 13:52:46 +0900
