=== debian/control ===
--- 
+++ 
@@ -42,7 +42,8 @@
  ${misc:Depends},
  libgr-framework0 (= ${binary:Version}),
  gr-framework-bin (= ${binary:Version}),
- gr-framework-plugin-base (= ${binary:Version})
+ gr-framework-plugin-base (= ${binary:Version}),
+ gr-framework-plugin-cairo (= ${binary:Version})
 Description: Universal framework of Graphical Kernel System (GKS) and OpenGL (metapackage)
  GR is a universal framework for cross-platform visualization
  applications. It offers developers a compact, portable and consistent
@@ -93,9 +94,7 @@
 Depends:
  ${shlibs:Depends},
  ${misc:Depends},
- dvipng,
- gr-framework-plugin-base (= ${binary:Version}),
- gr-framework-plugin-cairo (= ${binary:Version})
+ dvipng
 Description: Library of Graphical Kernel System (GKS) and OpenGL
  GR is a universal framework for cross-platform visualization
  applications. It offers developers a compact, portable and consistent
