=== debian/changelog ===
gr-framework (0.73.12+dfsg-2) unstable; urgency=medium

  * d/control
    - Require fonts-dejavu-core for default font
    - Require fonts-urw-base35,fonts-stix as built-in supported fonts
  * d/libgr-framework0.links
    - Add missing fallback about font metrics
  * d/patches/use-dejavu-sans-ttf.patch
    - Use DejaVuSans by default

 -- Kentaro Hayashi <kenhys@xdump.org>  Fri, 07 Feb 2025 21:56:38 +0900

gr-framework (0.73.12+dfsg-1) unstable; urgency=medium

  * New upstream version 0.73.12+dfsg

 -- Kentaro Hayashi <kenhys@xdump.org>  Sat, 25 Jan 2025 18:19:43 +0900
