=== debian/control ===
--- 
+++ 
@@ -94,7 +94,10 @@
 Depends:
  ${shlibs:Depends},
  ${misc:Depends},
- dvipng
+ dvipng,
+ fonts-dejavu-core,
+ fonts-urw-base35,
+ fonts-stix
 Description: Library of Graphical Kernel System (GKS) and OpenGL
  GR is a universal framework for cross-platform visualization
  applications. It offers developers a compact, portable and consistent
